"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = __importDefault(require("path"));
const tempy_1 = __importDefault(require("tempy"));
const fs_1 = __importDefault(require("fs"));
const launchTerminal_1 = __importDefault(require("./launchTerminal"));
function shellWindows(script, options) {
    var _a;
    const launchFilePath = path_1.default.join(tempy_1.default.directory(), "launchTerminal.bat");
    const environmentParams = [];
    if ((_a = options) === null || _a === void 0 ? void 0 : _a.env) {
        const env = options.env;
        for (const paramKey in env) {
            environmentParams.push(`set ${paramKey}=${env[paramKey]}`);
        }
    }
    const batFile = `
@echo off
${environmentParams.join("\n")}
start cmd.exe @cmd /C ${script}
pause
exit`;
    fs_1.default.writeFileSync(launchFilePath, batFile);
    fs_1.default.chmodSync(launchFilePath, 0o751);
    launchTerminal_1.default(launchFilePath);
}
function shell(script, options) {
    var _a;
    const isWindows = /^win/.test(process.platform);
    const cwd = process.cwd();
    if (isWindows) {
        return shellWindows(script, options);
    }
    const launchFilePath = path_1.default.join(tempy_1.default.directory(), "launchTerminal");
    const moveToDirCommand = `cd ${cwd};`;
    const environmentParams = [];
    if ((_a = options) === null || _a === void 0 ? void 0 : _a.env) {
        const env = options.env;
        for (const paramKey in env) {
            environmentParams.push(`${paramKey}=${env[paramKey]} `);
        }
    }
    const scriptWithMovePrefix = moveToDirCommand + environmentParams.join("") + script;
    fs_1.default.writeFileSync(launchFilePath, scriptWithMovePrefix);
    // add execute permissions (-rwxr-xr-x)
    fs_1.default.chmodSync(launchFilePath, 0o751);
    launchTerminal_1.default(launchFilePath);
}
exports.default = shell;
//# sourceMappingURL=shell.js.map